unzip the tarfile in the tar measure - too much wasted space otehrwise.
[xfstests-dev.git] / 021
1 #! /bin/sh
2 # XFS QA Test No. 021
3 # $Id: 1.1 $
4 #
5 # xfs_db type attr test (pv 797508 linux-xfs & IRIX)
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
9
10 # This program is free software; you can redistribute it and/or modify it
11 # under the terms of version 2 of the GNU General Public License as
12 # published by the Free Software Foundation.
13
14 # This program is distributed in the hope that it would be useful, but
15 # WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
17
18 # Further, this software is distributed without any warranty that it is
19 # free of the rightful claim of any third person regarding infringement
20 # or the like.  Any license provided herein, whether implied or
21 # otherwise, applies only to this software file.  Patent licenses, if
22 # any, provided herein do not apply to combinations of this program with
23 # other software, or any other product whatsoever.
24
25 # You should have received a copy of the GNU General Public License along
26 # with this program; if not, write the Free Software Foundation, Inc., 59
27 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
28
29 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
30 # Mountain View, CA  94043, or:
31
32 # http://www.sgi.com 
33
34 # For further information regarding this notice, see: 
35
36 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
37 #-----------------------------------------------------------------------
38 #
39 # creator
40 owner=dxm@sgi.com
41
42 seq=`basename $0`
43 echo "QA output created by $seq"
44
45 here=`pwd`
46 tmp=/tmp/$$
47 status=0        # success is the default!
48 # get standard environment, filters and checks
49 . ./common.rc
50 . ./common.filter
51
52 _cleanup()
53 {
54         echo "*** unmount"
55         umount $SCRATCH_MNT 2>/dev/null
56         rm -f $tmp.*
57 }
58 trap "_cleanup; exit \$status" 0 1 2 3 15
59
60 _attr()
61 {
62         attr $* 2>$tmp.err >$tmp.out
63         exit=$?
64         sed -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;"\
65                 $tmp.out
66         sed -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;"\
67                 $tmp.err 1>&2
68         return $exit
69 }
70
71 _getfattr()
72 {
73         getfattr $* 2>$tmp.err >$tmp.out
74         exit=$?
75         sed -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;"\
76                 $tmp.out
77         sed -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g; s#$tmp[^ :]*#<TMPFILE>#g;"\
78                 $tmp.err 1>&2
79         return $exit
80 }
81
82 # real QA test starts here
83 _require_scratch
84
85 rm -f $seq.full
86 umount $SCRATCH_DEV >/dev/null 2>&1
87
88 echo "*** mkfs"
89 mkfs_xfs $SCRATCH_DEV >/dev/null \
90         || _fail "mkfs failed"
91   
92 echo "*** mount FS"
93 mount -t xfs $SCRATCH_DEV $SCRATCH_MNT >/dev/null \
94         || _fail "mount failed"
95         
96 testfile=$SCRATCH_MNT/testfile
97 echo "*** make test file 1"
98
99 touch $testfile.1
100 echo "v1" | _attr -s "a1" $testfile.1 >/dev/null
101 echo "v2--" | _attr -s "a2--" $testfile.1 >/dev/null
102 _getfattr --absolute-names $testfile.1
103 inum_1=`ls -li $testfile.1 | $AWK_PROG '{ print $1 }'`
104
105 echo "*** make test file 2"
106
107 touch $testfile.2
108 echo "value_1" | _attr -s "a1" $testfile.2 >/dev/null
109 echo "value_2" | _attr -s "a2-----" $testfile.2 >/dev/null
110 ( echo start ; dd if=/dev/zero bs=65525 count=1 ; echo end ) \
111         | _attr -s "a3" $testfile.2 >/dev/null
112 _getfattr --absolute-names $testfile.2
113
114 # print name and size from 1st line of output
115 _attr -g "a3" $testfile.2 | head -1
116
117 # print out the rest of the data apart from the header
118 # the size is +1 for an extra \n at the end
119 echo -n "size of attr value = "
120 _attr -g "a3" $testfile.2 | tail -3 | wc -c
121 echo ""
122
123 inum_2=`ls -li $testfile.2 | $AWK_PROG '{ print $1 }'`
124         
125 echo "*** unmount FS"
126 umount $SCRATCH_DEV >>$seq.full 2>&1 \
127         || _fail "umount failed"
128
129 echo "*** dump attributes (1)"
130
131 xfs_db -r -c "inode $inum_1" -c "print a.sfattr" $SCRATCH_DEV
132
133 echo "*** dump attributes (2)"
134
135 xfs_db -r -c "inode $inum_2" -c "a a.bmx[0].startblock" -c print $SCRATCH_DEV \
136         | perl -ne '
137 s/^(hdr.firstused =) (\d+)/\1 FIRSTUSED/;
138 s/^(hdr.freemap\[0-2] = \[base,size]).*/\1 [FREEMAP..]/;
139 s/^(entries\[0-2] = \[hashval,nameidx,incomplete,root,local]).*/\1 [ENTRIES..]/;
140         print;'
141
142 echo "*** done"
143 exit